<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit" @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="标签名" prop="name" required>
                    <el-input v-model="formData.name" clearable placeholder="请输入" :readonly="false" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="goodsLabelEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiGoodsLabelAdd, apiGoodsLabelEdit, apiGoodsLabelDetail } from '@/api/goods_label'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑商品标签' : '新增商品标签'
})

// 表单数据
const formData = reactive({
    id: '',
    name: '',
})


// 表单验证
const formRules = reactive<any>({
    name: [{
        required: true,
        message: '请输入标签名',
        trigger: 'blur'
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }


}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiGoodsLabelDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apiGoodsLabelEdit(data)
        : await apiGoodsLabelAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}


let list = ['pingguo', 'xiangjiao', 'list', 'sadasd']
let i = 0

const handAdd = () => {
    apiGoodsLabelAdd({ name: list[i] })
}


// let timer = setInterval(() => {
//     i++
//     if (i > list.length) {
//         clearTimeout(timer)
//         return
//     }
//     handAdd()
// }, 2000)



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
